<template>
    <div>
        <breadcrumb-component title="Grupos de produtos" :pages="breadPages"/>

        <panel-component title="Listar grupos de produtos" length="6">
            <div class="form-group col-md-6">
                <router-link class="btn btn-primary" :to="{name: 'product-categories.create'}">
                    <i class="fa fa-plus-circle"></i> Cadastrar grupos de produtos
                </router-link>
            </div>
            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Nome</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="(category, index) in this.productCategories.data" :key="index">
                        <td>{{category.name }}</td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'product-categories.edit', params: {id: category.id}}"
                                    class="btn btn-xs btn-info ">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(category)">
                                <i class="fa fa-remove"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <p>
                    Mostrando: {{productCategories.data.length}} de um total de: {{productCategories.total}} registros.</p>
                <pagination
                        :data="productCategories"
                        :limit="1"
                        @pagination-change-page="loadProductCategories">
                    <span slot="prev-nav">Anterior</span>
                    <span slot="next-nav">Próximo</span>
                </pagination>
            </div>
        </panel-component>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'product-categories', name: 'Grupos de produtos', active: false},
                    {link: 'product-categories', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadProductCategories()
        },

        computed: {
            productCategories() {
                return this.$store.state.productCategories.items
            }
        },

        methods: {
            loadProductCategories(page = 1) {
                this.$store.dispatch('loadProductCategories', {page: page})
            },

            confirmDestroy(category) {
                this.$snotify.confirm(`Deseja realmente apagar o grupo? Todos os produtos que possui esse
                grupo serão apagados: ${category.name} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyProductCategory(category.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            console.log('Clicked: No');
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyProductCategory(id) {
                this.$store.dispatch('destroyProductCategory', id)
                    .then(() => {
                        this.loadProductCategories()
                        this.$snotify.success('Grupo apagado com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar o grupo!', 'Error')
                    })
            }
        }
    }
</script>